package com.infosupport.jewelshop;

import java.util.List;

import org.apache.wicket.AttributeModifier;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.image.ContextImage;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.PageableListView;
import org.apache.wicket.markup.html.navigation.paging.PagingNavigator;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import com.infosupport.jewelshop.domain.Jewel;
import com.infosupport.jewelshop.models.JewelModel;

public class HomePage extends MasterPage {

	private static final long serialVersionUID = -4819551977149480867L;

	public HomePage(PageParameters parameters) {
		super(parameters);

		IModel<List<Jewel>> jewelModel = new JewelModel();
		PageableListView<Jewel> jewelList = new PageableListView<Jewel>(
				"jewels", jewelModel, 5) {

			private static final long serialVersionUID = 4722910342262133462L;

			@SuppressWarnings("serial")
			@Override
			protected void populateItem(ListItem<Jewel> item) {
				Jewel jewel = item.getModelObject();
				String description = jewel.getDetails();

				WebMarkupContainer container = new WebMarkupContainer(
						"specialIcon");
				container.setVisible(jewel.isSpecialProduct());
				item.add(container);

				ContextImage image = new ContextImage("productImg", "images/"
						+ jewel.getImage());
				item.add(image);
				item.add(new Label("productName", jewel.getName()));
				item.add(new Label("productDetails", description.substring(0,
						description.indexOf(' ', 150)) + "..."));
				Link<Jewel> lnkDetails = new Link<Jewel>("detailsLink",
						Model.of(jewel)) {
					@Override
					public void onClick() {
						setResponsePage(JewelDetailsPage.class,
								JewelDetailsPage
										.createPageParameters(getModelObject()));
					}
				};
				lnkDetails.add(AttributeModifier.append("title", "Dit is een: "
						+ jewel.getName() + " en kost: " + jewel.getPrice()
						+ ". Klik voor meer info"));

				item.add(lnkDetails);
			}
		};
		PagingNavigator navigator = new PagingNavigator("navigator", jewelList);
		add(navigator);
		add(jewelList);

	}
}
