package com.infosupport.jewelshop;

import java.util.ArrayList;
import java.util.List;

import org.apache.wicket.extensions.markup.html.repeater.data.table.DefaultDataTable;
import org.apache.wicket.extensions.markup.html.repeater.data.table.IColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.PropertyColumn;
import org.apache.wicket.extensions.markup.html.repeater.data.table.filter.TextFilteredPropertyColumn;
import org.apache.wicket.model.Model;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import com.infosupport.jewelshop.datatables.JewelDataProvider;
import com.infosupport.jewelshop.domain.Jewel;

public class JewelsOverview extends MasterPage {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1072341923310796822L;
	private DefaultDataTable<Jewel> dataTable;

	public JewelsOverview(final PageParameters parameters) {
		super(parameters);
		List<IColumn<Jewel>> columns = new ArrayList<IColumn<Jewel>>();
		columns.add(new PropertyColumn<Jewel>(Model.of("Name"),
				Jewel.PROP_NAME, Jewel.PROP_NAME));
		columns.add(new TextFilteredPropertyColumn<Jewel, String>(Model
				.of("Price"), Jewel.PROP_PRICE, Jewel.PROP_PRICE) {
			private static final long serialVersionUID = 8551054143775595123L;

			@Override
			public String getCssClass() {
				return "numeric";
			}
		});

		JewelDataProvider jewelDataProvider = new JewelDataProvider();
		dataTable = new DefaultDataTable<Jewel>("jewelTable", columns,
				jewelDataProvider, 5);

		add(dataTable);
	}
}
