package com.infosupport.jewelshop;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import com.infosupport.jewelshop.components.BasketPanel;

public abstract class MasterPage extends WebPage {

	private static final long serialVersionUID = 1147735690745915051L;

	protected static final String BASKET_PANEL_ID = "basket";

	public MasterPage(final PageParameters parameters) {
		add(new BookmarkablePageLink<HomePage>("home", HomePage.class));
		add(new BookmarkablePageLink<HomePage>("contact", ContactPage.class));
		add(new BookmarkablePageLink<HomePage>("overview", JewelsOverview.class));

		BasketPanel basketPanel = new BasketPanel(BASKET_PANEL_ID, getSession()
				.getBasket());
		basketPanel.setOutputMarkupId(true);
		add(basketPanel);
	}

	@Override
	public JewelSession getSession() {
		return (JewelSession) super.getSession();
	}
}
