package com.infosupport.jewelshop.components;

import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.Model;
import org.apache.wicket.model.PropertyModel;

import com.infosupport.jewelshop.JewelDetailsPage;
import com.infosupport.jewelshop.domain.Basket;
import com.infosupport.jewelshop.domain.BasketItem;

public class BasketPanel extends Panel {

	private static final long serialVersionUID = 7799532731838436417L;

	public BasketPanel(String id, Basket basket) {
		super(id);

		ListView<BasketItem> items = generateBasketItems(basket);
		add(items);
	}

	private ListView<BasketItem> generateBasketItems(Basket basket) {
		ListView<BasketItem> items = new ListView<BasketItem>("items",
				basket.getBasketItems()) {

			private static final long serialVersionUID = -4239020732496834571L;

			@Override
			protected void populateItem(ListItem<BasketItem> item) {
				generateBasketItem(item);
			}
		};
		return items;
	}

	private void generateBasketItem(ListItem<BasketItem> item) {
		BasketItem basketItem = item.getModelObject();

		Link<BasketItem> linkJewelDetails = generateLinkJewelDetails(basketItem);
		linkJewelDetails.add(new Label("name", new PropertyModel<String>(
				basketItem, "jewel.name")));
		item.add(linkJewelDetails);
		item.add(new Label("items", new PropertyModel<String>(basketItem,
				"count")));
		item.add(new Label("subtotal", new PropertyModel<String>(basketItem,
				"subtotal")));
	}

	private Link<BasketItem> generateLinkJewelDetails(BasketItem basketItem) {
		Link<BasketItem> ajaxLink = new Link<BasketItem>("details",
				Model.of(basketItem)) {
			private static final long serialVersionUID = 1788334480638901414L;

			public void onClick() {
				onClickJewelDetails(getModelObject());
			}
		};
		return ajaxLink;
	}

	private void onClickJewelDetails(BasketItem basketItem) {
		setResponsePage(JewelDetailsPage.class,
				JewelDetailsPage.createPageParameters(basketItem.getJewel()));
	}
}
