package com.infosupport.jewelshop.domain;

import java.io.Serializable;

public class BasketItem implements Serializable {

	private static final long serialVersionUID = 6444742316576430685L;

	public static final String PROP_JEWEL = "jewel";

	public static final String PROP_COUNT = "count";

	private final Jewel jewel;
	private int count;

	public BasketItem(int count, Jewel jewel) {
		this.count = count;
		this.jewel = jewel;
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public Jewel getJewel() {
		return jewel;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((jewel == null) ? 0 : jewel.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BasketItem other = (BasketItem) obj;
		if (jewel == null) {
			if (other.jewel != null)
				return false;
		} else if (!jewel.equals(other.jewel))
			return false;
		return true;
	}

	public double getSubtotal() {
		return jewel.getPrice() * count;
	}
}
