package com.infosupport.jewelshop.domain;

import java.io.Serializable;
import java.util.Arrays;
import java.util.List;

public class Country implements Serializable {

	public static final String PROP_COUNTRY_CODE = "countryCode";

	public static final String PROP_FULL_NAME = "fullname";

	private static final long serialVersionUID = 1894147083986533193L;

	public static final Country NL = new Country("Netherlands", "NL");
	public static final Country BE = new Country("Belgium", "BE");
	public static final Country CA = new Country("Canada", "CA");

	public static final List<Country> getPoplulairCountries() {
		return Arrays.asList(NL, BE, CA);
	}

	private String fullname;

	private String countryCode;

	public String getFullname() {
		return fullname;
	}

	public String getCountryCode() {
		return countryCode;
	}

	private Country(String fullname, String countryCode) {
		super();
		this.fullname = fullname;
		this.countryCode = countryCode;
	}
}
