package com.infosupport.jewelshop.domain;

import java.util.Locale;

import org.apache.wicket.util.convert.ConversionException;
import org.apache.wicket.util.convert.IConverter;

public class DutchZipCodeConverter implements IConverter<DutchZipCode> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3973253566194825530L;

	public DutchZipCode convertToObject(String value, Locale locale) {
		String zipValue = value.replaceAll(" ", "").toUpperCase();
		if (zipValue.matches("[0-9]{4}[A-Z]{2}")) {
			return new DutchZipCode(zipValue.substring(4, 5),
					zipValue.substring(0, 3));
		} else {
			throw new ConversionException("Geen geldige postcode...");
		}
	}

	public String convertToString(DutchZipCode value, Locale locale) {
		return value.getNumbers() + value.getLetters();
	}

}
