package com.infosupport.jewelshop.domain;

import java.io.Serializable;

public class Jewel implements Serializable {

	public static final String PROP_NAME = "name";

	public static final String PROP_ID = "id";

	public static final String PROP_PRICE = "price";

	public static final String PROP_NEW_PRODUCT = "newProduct";

	public static final String PROP_DETAILS = "details";

	public static final String PROP_SPECIAL_PRODUCT = "specialProduct";

	public static final String PROP_IMAGE = "image";

	private static final long serialVersionUID = 1307800488047274298L;

	private Long id;

	private String name;

	private Double price;

	private Boolean newProduct;

	private String details;

	private boolean specialProduct;

	private String image;

	public Jewel(Long id, String image, boolean specialProduct, String name,
			Double price, Boolean newProduct, String gemstoneDescription) {
		super();
		this.id = id;
		this.image = image;
		this.specialProduct = specialProduct;
		this.name = name;
		this.price = price;
		this.newProduct = newProduct;
		this.details = gemstoneDescription;
	}

	public String getImage() {
		return image;
	}

	public void setImage(String image) {
		this.image = image;
	}

	public boolean isSpecialProduct() {
		return specialProduct;
	}

	public void setSpecialProduct(boolean specialProduct) {
		this.specialProduct = specialProduct;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Double getPrice() {
		return price;
	}

	public void setPrice(Double price) {
		this.price = price;
	}

	public Boolean getNewProduct() {
		return newProduct;
	}

	public void setNewProduct(Boolean newProduct) {
		this.newProduct = newProduct;
	}

	public String getDetails() {
		return details;
	}

	public void setDetails(String details) {
		this.details = details;
	}

	public Long getId() {
		return id;
	}

	public String getShortDescription() {
		if (details != null) {
			if (details.length() < 150) {
				return details;
			} else {
				int index = details.indexOf(' ', 150);
				if (index > 0) {
					return details.substring(0, index);
				} else {
					return details.substring(0, 150);
				}
			}
		} else {
			return "";
		}
	}

	public void setId(Long id) {
		this.id = id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Jewel other = (Jewel) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

}
