package com.infosupport.jewelshop.srv;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import com.infosupport.jewelshop.domain.Jewel;
import com.infosupport.jewelshop.domain.JewelNotFoundException;

public class JewelInventorySrv {

	private static final JewelInventorySrv instance = new JewelInventorySrv();

	private final List<Jewel> jewels;

	private JewelInventorySrv() {
		jewels = new ArrayList<Jewel>();
		jewels.add(new Jewel(
				1L, "thumb1.gif",
				false,
				"Jaspis",
				3567.23,
				false,
				"Jaspis is een opake en fijnkristallijne variteit van kwarts en de chemische samenstelling van jaspis is identiek aan die van agaat, vuursteen en hoornkiezel. De kleuren zijn variabel, van geel via rood en roodbruin tot groen. Jaspisstenen worden geslepen en gepolijst om in sieraden gezet te worden.De naam jaspis is via het Latijn en het Grieks (aspis) ontleend aan een Semitische taal."));
		jewels.add(new Jewel(
				2L, "thumb2.gif",
				false,
				"Saffier",
				8372.23,
				true,
				"Saffieren zijn al sinds mensenheugenis geliefde edelstenen, vanwege hun grote schoonheid en hun buitengewone eigenschappen. In het verleden werden alle blauwe stenen 'saffier' genoemd. Pas in het begin van de 19de eeuw werden ze samen met robijnen als zelfstandige edelstenen binnen de korundgroep beschouwd. Saffieren worden buitengewone eigenschappen toegeschreven. De saffier verleent zijn eigenaar kracht, eer en onsterfelijkheid. Hij was het symbool voor rijkdom en voorkwam tweespalt en smart. De saffier is een van de 'negen edelstenen' in de Thaise Orde van de Negen Edelstenen."));
		jewels.add(new Jewel(
				3L, "thumb2.gif",
				true,
				"Robijn",
				3812.03,
				false,
				"De robijn (afgeleid van het Latijnse ruber, 'rood') is een rode edelsteen, een variteit van het mineraal korund waarin de kleur hoofdzakelijk door chroom wordt veroorzaakt. Natuurlijke robijnen zijn uitzonderlijk zeldzaam, terwijl kunstmatig vervaardigde exemplaren betrekkelijk goedkoop zijn. Naast de heldere edelsteen robijn bestaat ook de minder heldere halfedelsteen met dezelfde naam."));
		jewels.add(new Jewel(
				4L, "thumb1.gif",
				false,
				"Smaragd",
				7653.23,
				false,
				"Smaragd ontstaat door een combinatie van opdringende magma en metamorfe omzetting van gesteenten. Afzettingen komen daarom voor in pegmatietgangen of in de omgeving daarvan. De winning van kristallen vindt bijna uitsluitend plaats uit het moedergesteente, waar de smaragd gegroeid is in kleine gangen of op de wanden van holten. Alluviale afzettingen kunnen nauwelijks ontstaan, omdat het soortelijk gewicht van smaragd vergelijkbaar is met dat van kwarts."));
		jewels.add(new Jewel(
				5L, "thumb2.gif",
				false,
				"Sardonyx",
				8765.12,
				false,
				"Sardonyx is een kwarts-variteit. De kleur van de steen kan licht gevlamd zwart, bruin, rood en wit gestreept zijn. Vindplaatsen zijn onder andere Brazili, Uruguay, India en Ruslanden zeer zelden in de Verenigde Staten van Amerika"));
		jewels.add(new Jewel(
				6L, "thumb3.gif",
				false,
				"Turkoois",
				1200.14,
				false,
				"Het groene, geelgrijze, lichtblauwe, maar typisch blauwgroene turkoois heeft een wasglans en een vaal blauwwitte streepkleur. Het kristalstelsel is triklien en de splijting is perfect volgens het kristalvlak [001] en goed volgens [010]; overigens komt het nagenoeg alleen in cryptokristallijne vormen voor dus is de splijting in de praktijk niet waar te nemen. De gemiddelde dichtheid is 2,7 en de hardheid is 5 tot 6. Turkoois is niet radioactief."));
		jewels.add(new Jewel(
				7L, "thumb1.gif",
				false,
				"Amethist",
				3245.14,
				false,
				"Metamorfieten, hydrothermaal, alluviale afzettingen. De kristallen groeien steeds op een onderlaag, de prisma's zijn vaak zwak ontwikkeld en daardoor overheersen de kristalspitsen spitamethist; hier is ook de kleur het krachtigste. Deze gedeelten worden er afgeklopt, dat wil zeggen, voor verder gebruik afgebroken. Door branden bij een temperatuur tussen 470 en 750 graden ontstaan lichtgele, roodbruine, groene of kleurloze variteiten. Er bestaan amethisten die bij daglicht geleidelijk verbleken. Met radiumbestraling is de oorspronkelijke kleur weer te herstellen. De kleur wordt veroorzaakt door ijzer in combinatie met ioniserende straling. Bij kunstlicht is amethist minder fraai."));
		jewels.add(new Jewel(
				8L, "thumb2.gif",
				false,
				"Opaal",
				8765.12,
				false,
				"Het mineraal opaal is een amorfe variteit van kwarts, SiO2nH2O, gehydrateerd siliciumdioxide met een waterpercentage van soms wel 20%. Opaal kan kleurloos zijn, wit, melkachtige blauw, grijs, rood, geel, groen, bruin en zwart. Vaak kunnen veel van deze kleuren meteen worden gezien, veroorzaakt door interferentie en diffractie van licht dat door minieme, regelmatig gerangschikte openingen binnen de microstructuur van het opalen gaat, bekend als het rooster van Bragg. Deze openingen worden gevuld met secundair kiezelzuur en vormen dunne lamellen binnen het opaal tijdens verharding. De term opalescentie wordt gebruikt om dit unieke en mooie fenomeen te beschrijven, hoewel kleurenspel een betere term zou zijn.Het opaal is n van de mineralen die fossielen vormen of kunnen vervangen. De resulterende fossielen worden gespaard door verzamelaars. 'Opaal' is afgeleid van het Oudindische woord pala', dat edelsteen betekent. Men maakt onderscheid tussen de glinsterende edelopalen, de geelrode vuuropalen en de gewone opalen. Hun fysische eigenschappen vertonen belangrijke verschillen.Het opaal is de officile edelsteen van Zuid-Australi."));
		jewels.add(new Jewel(
				9L, "thumb3.gif",
				false,
				"Beril",
				2345.98,
				false,
				"Het mineraal beril is een kleurloos, wit, gelig wit, geelgroen tot groen, roze, blauwig tot groenblauw, rood of goudgeel aluminium-beryllium-silicaat. Het mineraal, met de chemische formule Al2Be3(SiO3)6, behoort tot de cyclosilicaten."));
		jewels.add(new Jewel(
				10L, "thumb1.gif",
				false,
				"Barnsteen",
				1235.98,
				false,
				"Barnsteen (onjuist ook wel amber genoemd) is een fossiele hars die afkomstig is van naaldbomen. Deze bomen werden veelal aangeduid met de wetenschappelijke soortnaam Pinus succinifera, een nog levende dennensoort. De hars is miljoenen jaren geleden uit de bomen gedropen en daarna versteend. Barnsteen stamt uit het Mesozocum tot aan het Kwartair. Barnsteen is meestal warmgeel tot donkerrood van kleur, maar er bestaan ook meer groen-, blauw- of zelfs zwartgekleurde soorten. Doorzichtige barnsteen wordt algemeen het mooist gevonden en is het kostbaarst.Mineralogisch bezien heeft barnsteen een amorfe structuur. Het is vrij zacht, de hardheid bedraagt 2-2,5."));
		jewels.add(new Jewel(
				11L, "thumb2.gif",
				false,
				"Chrysopraas",
				3842.09,
				false,
				"Chrysopraas (Grieks: chrysos, goud en prason, prei) is een variteit van het mineraal chalcedoon, waarmee het de chemische, optische en fysische eigenschappen deelt. Het kan kleine hoeveelheden nikkel bevatten en heeft een kleur die kan variren van appelgroen tot diepgroen.Chrysopraas wordt vaak gebruikt als edelsteen.Chrysopraas wordt gewonnen in Australi (Queensland en West-Australi), Duitsland, Polen, Rusland, de Verenigde Staten (in de staten Arizona en Californi) en Brazili."));
		jewels.add(new Jewel(
				12L, "thumb3.gif",
				false,
				"Diamant",
				9999.23,
				false,
				"Diamant is een van de vier natuurlijke allotrope verschijningsvormen van koolstof (de meest voorkomende is grafiet). In diamant hebben de koolstof-koolstofbindingen de tetradische structuur. Het is voor zover bekend het hardste materiaal dat in de natuur voorkomt; het is dan ook het ijkpunt voor hardheid 10 op de hardheidsschaal van Mohs. Er zijn slechts twee industrieel vervaardigde materialen, namelijk Aggregated carbon nanorods en ultrahard fulleriet, die harder zijn. De diamant ontleent zijn naam aan het Griekse adamas, ontembaar of onoverwinnelijk, verwijzend naar zijn hardheid."));
		jewels.add(new Jewel(
				13L, "thumb1.gif",
				false,
				"Agaat",
				5678.98,
				false,
				"Agaat is een doorzichtige, maar soms ook opake variteit van kwarts en een subvariteit van chalcedoon. De chemische structuur van Agaat is identiek aan jaspis, vuursteen, hoornkies en wordt vaak samen met opaal gevonden. De kleurrijke, gestreepte specimens worden gebruikt als halfedelsteen. De naam agaat komt uit het Grieks (achats)."));
	}

	public static JewelInventorySrv getInstance() {
		return instance;
	}
	
	public Jewel getJewelById(Long id) throws JewelNotFoundException {
		for (Jewel jewel : jewels) {
			if (id.equals(jewel.getId())) {
				return jewel;
			}
		}
		throw new JewelNotFoundException(id);
	}

	public List<Jewel> getJewels() {
		return Collections.unmodifiableList(this.jewels);
	}
}
